<template>
  <div>
    <b-card class="animated fadeIn">
      <b-row>
        <h4 class="card-title">Giao dịch hôm nay</h4>
      </b-row>
      <b-row>
        <b-col md="12" class="my-1 float-right">
          <b-button size="sm" @click.stop="fetchPayments()" class="mr-1 float-right" align-self="end" variant="primary">Refresh</b-button>
        </b-col>
      </b-row>
      <b-table hover :items="sortedPayments" small :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="amount" slot-scope="data">
          <span v-if="data.item.salesman_paid == 0">{{ comma(data.value) }}</span>
          <span v-else-if="data.item.salesman_paid == data.value">{{ comma(data.value) }}</span>
          <span v-else>{{ comma(data.item.salesman_paid) }} / {{ comma(data.value) }}</span>
        </template>
        <span slot="status_label" slot-scope="data" v-html="data.value"></span>
        <template slot="actions" slot-scope="row" v-if="$store.state.is_admin == 1">
          <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->
          <button class="icon-btn" title="Xác nhận" @click.stop="showConfirmPaymentForm(row.item, row.index, $event.target)" v-if="row.item.status<4">
            <v-icon label="Xác nhận" name="clipboard-check" class="text-success" scale="1.5"></v-icon>
          </button>

          <button v-if="row.item.payments_to_company_details != null" class="icon-btn" @click="showHistory(row.item, row.index, $event.target)">
            <v-icon label="Lịch sử giao dịch" name="history" class="text-info" scale="1.5"></v-icon>
          </button>
          <button class="icon-btn" title="Xác nhận" @click.stop="editPayment(row.item)">
            <v-icon label="Xóa" name="edit" class="text-warning" scale="1.5"></v-icon>
          </button>
          <button class="icon-btn" title="Xác nhận" @click.stop="confirmDeletePayment(row.item)">
            <v-icon label="Xóa" name="times" class="text-danger" scale="1.5"></v-icon>
          </button>
        </template>
      </b-table>
      <b-row>
        <b-col md="9" xs="6" class="my-1">
          <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
        </b-col>
        <b-col md="3" xs="6" class="my-1 float-right">
          <b-form-group horizontal label="Hiển thị">
            <b-form-select :options="pageOptions" v-model="perPage" />
          </b-form-group>
        </b-col>
      </b-row>
    </b-card>
    <confirm-payment-modal ref="confirmPaymentModalRef" :payment="selectedPayment"></confirm-payment-modal>
    <payment-history-modal :payment="selectedPayment" ref="paymentHistoryRef"></payment-history-modal>
    <edit-payment-modal ref="editPaymentModal" :payment="selectedPayment"></edit-payment-modal>
  </div>
</template>

<script>
import { alerts } from "@/utils";
import { socket, http } from "@/services";
import ConfirmPaymentModal from "./ConfirmPaymentModal";
import PaymentHistoryModal from "./PaymentHistoryModal";
import EditPaymentModal from "./EditPaymentModal";
export default {
  components: { ConfirmPaymentModal, PaymentHistoryModal, EditPaymentModal },
  data() {
    return {
      fields: [
        {
          key: "id",
          label: "Mã GD",
          sortable: true
        },
        {
          key: "agency.name",
          label: "Tên đại lý",
          sortable: true
        },
        {
          key: "salesman.name",
          label: "Nhân viên GD",
          sortable: true
        },
        {
          key: "amount",
          label: "Số tiền",
          sortable: true
        },
        {
          key: "created_at",
          label: "Ngày thu tiền",
          sortable: true,
          formatter: value => {
            return this.$moment(value).format("DD/MM/YYYY HH:mm:ss");
          }
        },
        {
          key: "status_label",
          label: "Trạng thái",
          sortable: true
        },

        {
          key: "actions",
          label: "Xác nhận nộp tiền"
        }
      ],
      payments: [],
      currentPage: 1,
      perPage: 20,
      totalRows: 0,
      pageOptions: [5, 10, 15, 20],
      selectedPayment: null,
      bodyText: "",
      current: ""
    };
  },
  created() {
    this.fetchPayments();
  },
  mounted: function() {
    //this.time();
  },
  methods: {
    fetchPayments() {
      http.get("/payment", response => {
        this.payments = response.data;
        this.totalRows = response.data.length;
      });
    },
    /**
     * Post a request to confirm payment
     * @param {int} payment_id
     * @param {string} reference_code
     *
     */
    confirmPayment(payment_id, reference_code) {
      http.post(
        "/payment/confirm",
        {
          id: payment_id,
          reference_code: reference_code
        },
        response => {
          return response;
        }
      );
    },
    editPayment(payment) {
      this.selectedPayment = payment;
      this.$refs.editPaymentModal.showModal();
    },
    showConfirmPaymentForm(item, index, button) {
      this.selectedPayment = item;
      this.$refs.confirmPaymentModalRef.showModal();
    },
    showHistory(item, index, button) {
      this.selectedPayment = item;
      this.$refs.paymentHistoryRef.toggleModal();
    },
    async deletePayment() {
      return new Promise((resolve, reject) => {
        http.post(
          "/payment/destroy",
          { id: this.selectedPayment.id },
          response => {
            var payment = this.payments.find(
              payment => payment.id === payment.id
            );
            if (payment && this.payments.indexOf(payment) > -1) {
              this.payments.splice(this.payments.indexOf(payment), 1);
            }
            return resolve(response.data);
          },
          error => {
            alerts.error(error.response.status + ":" + error.response.data.msg);
          }
        );
      });
    },
    confirmDeletePayment(item) {
      this.selectedPayment = item;
      alerts.ajaxConfirm(
        "Bạn chắc chắn muốn xóa giao dịch này?",
        "warning",
        this.deletePayment,
        this.fetchPayments
      );
    }
  },
  computed: {
    sortedPayments() {
      return this.payments.sort(
        (a, b) => new Date(b.created_at) - new Date(a.created_at)
      );
    }
  }
};
</script>
